// Program to receive a number on serial port and blink the right number of time. 
// By Francis Lance april 2019.

int const NUMBEROFSLAVE = 2; // Number of slave
int const pushButton = 7; // Define push button pin
int numberOfBLink = 0;    // Variable for the number of blink
String stringToSend = ""; // Buffer to send the string
int slaveID = 1;          // Slave ID for communication

// the setup routine
void setup() {
  
  Serial.begin(9600); // initialize serial communication at 9600 bits per second:
  
  pinMode(pushButton, INPUT);// Define the push button pin as an input:
}

// the main loop
void loop() {
  
  stringToSend = ""; // Reset the string
  while(digitalRead(pushButton)){} //While the button is not pressed read the state of the button.
  numberOfBLink++; // Add one blink
  
  if(numberOfBLink > 6) // Limit the number of blink at 6
  {
    numberOfBLink = 0;  // Reset the number of blink to 0
  }
  if(slaveID > NUMBEROFSLAVE) // Limit the number of slave
  {
    slaveID = 1;  // Reset the number of the slave to 1
  }
  stringToSend = stringToSend + slaveID + ' ' + numberOfBLink;  // Merge all the informations in one string
  Serial.println(stringToSend);   // Send the number of blink on the serial port
  slaveID++;    // Change the slave ID
  delay(250);        // delay to press and release the button.
}
