//Program to receive a number on serial port and blink the right number of time. By Francis Lance april 2019.
#include <SoftwareSerial.h>
SoftwareSerial mySerial(0, 1); // RX, TX

int number = 0; // Variable to store my number
char c = 'a'; // Received character
char NumberString[] = "123"; // store each character in this array (size is 4)
int i=0; // Array index

void setup() {
  mySerial.begin(9600); // Initialize serial port
  pinMode(3, OUTPUT);
  digitalWrite(3, HIGH);
}
void loop() { // run over and over

 while (mySerial.available()) { // While characters are ready to read in the serial buffer
    delay(2); // This delay is very important because it gives time to the characters 
              //to put themselves in the buffer. Without this delay, you will miss 
              //some characters.
    c = mySerial.read(); // Read the character in the buffer
    NumberString[i] = c; // Insert the character in the array.
    i++; // Move the array index for the next character.
 }
 if (i >0) { // if we read some characrers
    NumberString[i] ='\0'; // Insert the NUL character at the end of the array
    number = atoi(NumberString); // Convert the array in integer
    for( int j = 0; j < number; j++){ // for the number a receive of time, blink the LED
      digitalWrite(3, LOW);   // turn the LED on (LOW is the voltage level)
      delay(500);    // wait for a half second
      digitalWrite(3, HIGH);    // turn the LED off (HIGH is the voltage level)
      delay(500);    // wait for a half second
      
      }
    NumberString[0]='\0'; // Reset the array
    i=0;// Reset the index at the begenning
 } 
}
